#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <tap.h>
#include "libFirebird.h"

#define ID_USERTAP 0xbdb02f21
TAP_ID( ID_USERTAP );
TAP_PROGRAM_NAME("timeshift_extend2");
TAP_AUTHOR_NAME("bdb");
TAP_DESCRIPTION("Extends the timeshift buffer to 2 hours");
TAP_ETCINFO(__DATE__);


dword fw_patch1 = 0;
dword fw_patch2 = 0;
dword fw_patch3 = 0;

dword TAP_EventHandler( word event, dword param1, dword param2 )
{
	return param1;
}

void set_timeshift_2hour()
{
    //store the timeshift position every 2 seconds [instead of every 1 second]
    //8014affc 24 05 00 64                             li      $a1, 0x64            //100 x 10ms = 1second
    *(word *)(fw_patch1+0x0a) = 0x00c8;


    //change the roundall to divide by 15 instead of 60
    //roundell / DoPVRInfo
    //80168b74 24 0e 00 3c                             li      $t6, 0x3C            //minutes
    *(word *)(fw_patch2+0x06) = 0x001e;
    //80168b7c 24 18 00 3c                             li      $t8, 0x3C            //seconds
    *(word *)(fw_patch2+0x0e) = 0x001e;
    //80168bc4 00 20 38 21                             move    $a3, $1              //x4
    *(dword *)(fw_patch2+0x54) = 0x00013840;     //--> sll     $a3, $1, 2


    //and the progress bar
    //8017d408 24 19 00 3c                             li      $t9, 0x3C            //minutes
    *(word *)(fw_patch3+0x06) = 0x001e;
    //8017d440 24 18 00 3c                             li      $t8, 0x3C            //seconds
    *(word *)(fw_patch3+0x3e) = 0x001e;
    //8017d458 00 20 38 21                             move    $a3, $1              //x4
    *(dword *)(fw_patch3+0x54) = 0x00013840;     //--> sll     $a3, $1, 2
}

int TAP_Main(void)
{
    int ret;

	ret = InitTAPex();
	if (ret == 0) {
		TAP_Print("\nUnsupported firmware %d:%x\n", SysID, ApplID);
		return 0;
	}

	fw_patch1 = FindInstructionSequence(
		"24c6b2a8 0c04d994 24050064 938487c0 3c1981db 2739a184 0004c200 241e0040 0338b021",
		"ffff0000 ff000000 ffffffff ffff0000 ffff0000 ffff0000 ffffffff ffffffff ffffffff",
		0x80100000, 0x80180000, 0, FALSE);

	fw_patch2 = FindInstructionSequence(
		"0006000d 240e003c 3c05802e 2418003c 24a5a448 03ce001a 00000812 15c00002 00203021 0007000d 2401ffff 15c10004 3c018000 17c10002 00000000 0006000d 00000000 00000000 03d8001a 00000810 17000002 00203821 0007000d",
		"ffffffff ffffffff ffff0000 ffffffff ffff0000 ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff",
		0x80120000, 0x801a0000, 0, FALSE);

	fw_patch3 = FindInstructionSequence(
		"0014f023 2419003c 03d9001a 00000812 17200002 00203021 0007000d 2401ffff 17210004 3c018000 17c10002 00000000 0006000d 3c1581c3 3c05802e 2418003c 26b5c868 24a5a664 03d8001a 00000810 17000002 00203821 0007000d",
		"ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffff0000 ffff0000 ffffffff ffff0000 ffff0000 ffffffff ffffffff ffffffff ffffffff ffffffff",
		0x80120000, 0x801a0000, 0, FALSE);


//    printf("\nfw_patch1=%x", fw_patch1);
//    printf("\nfw_patch2=%x", fw_patch2);
//    printf("\nfw_patch3=%x", fw_patch3);

	if (fw_patch1 == 0 || fw_patch2 == 0 || fw_patch3 == 0)	{
		TAP_Print("\nUnsupported firmware %d:%x, or patch already applied\n", SysID, ApplID);
		return 0;
	}

    TAP_Print("\nPatching timeshift to 2 hours ...\n");
    set_timeshift_2hour();

	return 0;
}
